﻿using System;
using System.Collections;

namespace tune2
{
    class myQueue
    {
        Queue myQ = new Queue();

        public void add(Byte[] myArr)
        {
            lock (myQ.SyncRoot)
            {
                myQ.Enqueue(myArr);
            }
        }

        public void add(String s)
        {
            lock (myQ.SyncRoot)
            {
                myQ.Enqueue(s);
            }
        }

        public Byte[] get()
        {
            Byte[] ma;

            lock (myQ.SyncRoot)
            {
                if (myQ.Count == 0)
                {
                    Byte[] x = new Byte[1] { 0 };
                    return x;
                }
                ma = (Byte[])myQ.Dequeue();
            }
            return ma;
        }

        public Byte[] Peek()
        {
            Byte[] ma;

            lock (myQ.SyncRoot)
            {
                if (myQ.Count == 0)
                {
                    Byte[] x = new Byte[1] { 0 };
                    return x;
                }
                ma = (Byte[])myQ.Peek();
            }
            return ma;
        }

        public String gets()
        {
            String ma;

            lock (myQ.SyncRoot)
            {
                ma = (String)myQ.Dequeue();
            }
            return ma;
        }

        public int Count()
        {
            int result;

            lock (myQ.SyncRoot)
            {
                result = myQ.Count;
            }
            return result;
        }

        public void Clear()
        {
            lock (myQ.SyncRoot)
            {
                myQ.Clear();
            }
        }
    }
}
